# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import zipfile
import re


def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

  
    url_base = "https://www.inputdirector.com/downloads.html"
    response = requests.get(url_base,allow_redirects=True, proxies=proxies)
    # Extract the correct div using bs_find_all
    divs = bs_find_all(response.text, "ul", proxies=proxies)
    zip_file = None
    for div in divs:
        if zip_file:
            break
        links = div.find_all('a', href=True)
        for link in links:
            if link['href'].endswith('.zip'):
                href = link['href']
                zip_file = href
                download_url ="https://www.inputdirector.com/" + zip_file
                latest_bin = zip_file.split('/')[-1]
                # Utiliser une expression régulière pour extraire la version
                match = re.search(r'v?(\d+\.\d+)', latest_bin)
                if match:
                    version = match.group(1)
                    break


    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)


    # Extracting the .exe file from the .zip archive
    with zipfile.ZipFile(latest_bin, "r") as zip_ref:
        zip_ref.extractall()

        exe_file = None
        for file in zip_ref.namelist():
            if file.endswith(".exe"):
                exe_file = file
                print(f"Extracted {exe_file}")
                break
 
    version = get_version_from_binary(exe_file)
    # Mettre à jour le package
    control.set_software_version(version)
    control.save_control_to_wapt()    
        

